# 151229 - script to blast OTUs against NCBI / BLOD
setwd("~/Documents/UNI_und_VORLESUNGEN/11 phd projects/1 Meta SCHMALNAU/2 HiSeq TierMix scripts/7 BOLD")

fastafile <- "../6 Blasting/SUBSET_0.003/OTU_BF1_BR2.fasta"
folder <- "BOLD_BF1_BR2"
hittable <- "../6 Blasting/SUBSET_0.003/OTU_BF1_BR2_242.csv"
outputname <- "OTU_BF1_BR2_taxonomy.csv"


# calculate read length

data <- readLines(fastafile)

ID <- grep(">", data)
rigth <- c(ID[-1]-1, length(data))
L <- NULL
for (i in 1:length(ID)){
L[i] <- sum(nchar(data[(ID[i]+1):rigth[i]]))
}
L <- data.frame("length" = as.numeric(L), "OTU" = sub(">", "", data[ID]), stringsAsFactors=F)

head(L)

data <- data.frame("OTU"=sub(">(OTU_.*);size.*", "\\1", L$OTU), "length"=L$length, stringsAsFactors=F)


f <- 1

table_list <- list.files(folder, full.names=T, pattern="_hacked.txt")

temp <- NULL
for (f in 1:length(table_list)){
BOLDdata <- read.table(table_list[f], stringsAsFactors=F)
OTU <- sub(".+(OTU_.*)_hacked.*", "\\1", table_list[f])
temp <- rbind(temp, cbind("OTU"=OTU, BOLDdata[1,]))
}

temp <- data.frame(temp, stringsAsFactors=F)

temp[temp==""] <- NA
speciesOK <- which(!is.na(temp$Species))

temp$Genus[speciesOK] <- temp$Species[speciesOK]

temp2 <- temp[,-c(5, 6, 9, 11)]

# merge Identification tables and OTU length in bp
meep <- merge(data, temp2, all=T)

OTUabund <- read.csv(hittable, sep=",")


names(meep)[3] <- "BOLD_ID"
final_tab <- merge(OTUabund, meep, sort=F, by.x="ID", by.y="OTU")

head(final_tab)



write.csv(final_tab, file= outputname)






