# 160414 - Primer evaluation

setwd("~/Documents/UNI_und_VORLESUNGEN/11 phd projects/1 meta FINNLAND/2 Misof - insecta/1 Rscripte/1 Primer_evaluation")



# COMPATE 2 PRIMERS
combine_2_primers <- function(fw, rw, threshold=60, file=NULL){
fw_data <- read.csv(fw, stringsAsFactors=F)
rw_data <- read.csv(rw, stringsAsFactors=F)

temp <- cbind(fw_data$sum, rw_data$sum, fw_data$sum + rw_data$sum)

if(!is.null(file)){
	write.csv(temp, file=file)
}

fail <- sum(temp[,3]>threshold, na.rm=T)
ok <- sum(temp[,3]<=threshold, na.rm=T)
gaps <- sum(is.na(temp[,3]))

return(c(ok, fail, gaps))
}


# SINGLE PRIMER FUNCTION
single_primer <- function(file, threshold=60){
temp <- read.csv(file, stringsAsFactors=F)

fail <- 0
ok <- 0
gaps <- 0

fail <- sum(temp$sum>threshold, na.rm=T)
ok <- sum(temp$sum<=threshold, na.rm=T)
gaps <- sum(is.na(temp$sum))

return(c(ok, fail, gaps))
}


# PROCESS BATCH FILES = ) from all taxa in folder!
files <- list.files("Primer_tables_v10", full.names=T)



order_names <- unique(sub(".*_#_(.*)_##_.*", "\\1", files))


primer_names <- unique(sub(".*_##_(.*)", "\\1", files))
#cbind(primer_names)

primer_names2 <- primer_names[c(7, 8, 5, 10, 11, 3, 1, 4, 2, 9, 6, 15, 22, 23, 21, 20, 18, 12, 13, 17, 19, 16, 14)]

cbind(primer_names2) # primer plotting order!


#count number of reads for each taxon!

temp_order_couting_files <- files[files %in% paste("Primer_tables_v10/R_#_", order_names, "_##_BR1.csv", sep="")]


number_of_reads_fasta <- NULL
for (i in 1:length(order_names)){
number_of_reads_fasta[i] <- length(readLines(temp_order_couting_files[i]))-1
}

order_stats <- data.frame(temp_order_couting_files, order_names, number_of_reads_fasta, stringsAsFactors=F)

# For now no subsetting!!!


# Plot performance of single insect perimers!

pdf("insect_eval_v17.pdf", width= 8, height= 9)

# MAKE PLOT
par(mfcol=c(length(order_stats$order_names)+3, length(primer_names2)+2), mar=c(0,0,0,0), mai=c(0,0,0,0), oma=c(1,4,4,1))

boxplotmeans <- NULL

plot(0, type="n", axes=F, xlab="", ylab="", xlim=c(0,2)) # empty plot

for (i in 1:length(order_stats$order_names)){
plot(0, type="n", axes=F, xlab="", ylab="", xlim=c(0,2)) # empty plot
text(2, 0, order_stats$number_of_reads_fasta[i], srt = 0, adj = 1, xpd = TRUE)
}
plot(0, type="n", axes=F, xlab="", ylab="", xlim=c(0,2)) # empty plot
plot(0, type="n", axes=F, xlab="", ylab="", xlim=c(0,2)) # empty plot

plot(0, type="n", axes=F, xlab="", ylab="", xlim=c(0,2)) # empty plot

for (i in 1:length(order_stats$order_names)){
plot(0, type="n", axes=F, xlab="", ylab="", xlim=c(0,2)) # empty plot
text(2, 0, sub(".._(.*)", "\\1", order_stats$order_names[i]), srt = 0, adj = 1, xpd = TRUE)
}
plot(0, type="n", axes=F, xlab="", ylab="", xlim=c(0,2)) # empty plot
plot(0, type="n", axes=F, xlab="", ylab="", xlim=c(0,2)) # empty plot


for (k in 1:length(primer_names2)){

plot(0, type="n", axes=F, xlab="", ylab="", xlim=c(0,2)) # empty plot
text(0.5, -0.8, sub(".csv", "\\1", primer_names2[k]), srt = 45, adj = 0, xpd = TRUE)

mean_scores <- NULL
mean_penalties <- NULL

for (i in 1:length(order_stats$order_names)){

temp_file_ID <- grep(paste(order_stats$order_names[i], "_##_", primer_names2[k],  sep=""), files)

meep <- single_primer(files[temp_file_ID], threshold=120)
pie(meep, col=c("Lightgreen", "tomato", "gray93"), labels=NA, radius=1, clockwise=T, border=0)
text(0,0, round(meep[1]/sum(meep[-3])*100))

mean_scores <- rbind(mean_scores, c(order_stats$order_names[i],meep))

# mean penalties
meanp <- read.csv(files[temp_file_ID])
mean_penalties[i] <- mean(meanp$sum, na.rm=T)

}

mean_scores <- data.frame(mean_scores, stringsAsFactors=F)
mean_scores[,2] <- as.numeric(mean_scores[,2])
mean_scores[,3] <- as.numeric(mean_scores[,3])
mean_scores[,4] <- as.numeric(mean_scores[,4])
mean_scores2 <- mean_scores[c(order_stats$number_of_reads_fasta>=100),-1]
mean_scores2 <- mean_scores2 / rowSums(mean_scores2)
meep <- colMeans(mean_scores2)
pie(meep, col=c("Green", "Red", "Gray"), labels=NA, radius=1, clockwise=T, border=0)
text(0,0, round(meep[1]/sum(meep[-3])*100))

# freshwater taxa
mean_scores3 <- mean_scores[c(3, 4, 7, 21, 24, 25, 29),-1]
mean_scores4 <- mean_scores3
mean_scores4 <- mean_scores4 / rowSums(mean_scores4)
meep <- colMeans(mean_scores4)
pie(meep, col=c("Green", "Red", "Gray"), labels=NA, radius=1, clockwise=T, border=0)
text(0,0, round(meep[1]/sum(meep[-3])*100))

# boxplot scores
boxplotmeans <- cbind(boxplotmeans, mean_penalties)

}

dev.off()


# make extra fro box plot!
pdf("insect_eval_v17_BOX.pdf", width= 8, height= 2.2, useDingbats=F)

# MAKE PLOT
par(mfcol=c(1, length(primer_names2)+2), mar=c(0,0,0,0), mai=c(0,0,0,0), oma=c(1,4,4,1))

plot(0, type="n", axes=F, xlab="", ylab="", xlim=c(0,2)) # empty plot
plot(0, type="n", axes=F, xlab="", ylab="", ylim=c(0,2000)) # empty plot
axis(2, at=c(0,120, 500,1000,1500, 2000), las=1)

means <- colMeans(boxplotmeans[which(order_stats$number_of_reads_fasta>=100),])
for (i in 1:length(primer_names2)){

boxplot(boxplotmeans[which(order_stats$number_of_reads_fasta>=100), i],  xlim=c(0.75, 1.25), ylim=c(0,1250), axes=F, col="white")
text(1, -20, round(digits=1, means[i]), srt=0, cex=0.75, col="Red")
}

dev.off()







###########################
# Compare primer pairs!!!


data <- read.csv("meta_primer_v7.csv", stringsAsFactors=F)
data  <- data[order(data$strand, data$bind),]


forward <- which(data$strand=="F")
reverse <- which(data$strand=="R")

paste("Primer_tables_v10/", data$strand[i], "_#_", order_names[1], "_##_", data$Primer.name[i], ".csv", sep="")



pdf("compar_primers_v17.pdf", width= 6, height= 5.8)


# MAKE PLOT
par(mfrow=c(length(forward)+1,length(reverse)+1), mar=c(0,0,0,0), mai=c(0,0,0,0), oma=c(1,4,4,1))

# Plot
plot(0, type="n", axes=F, xlab="", ylab="", xlim=c(0,2)) # empty plot

# reverse names!
for (i in reverse){
plot(0, type="n", axes=F, xlab="", ylab="", xlim=c(0,2)) # empty plot
text(0.5, -0.8, data$Primer.name[i], srt = 45, adj = 0, xpd = TRUE)
}




# plot combos
for (i in forward){
plot(0, type="n", axes=F, xlab="", ylab="", xlim=c(0,2)) # empty plot
text(2, 0, data$Primer.name[i], srt = 0, adj = 1, xpd = TRUE)

for (k in reverse){

if(data$bind[k]-data$bind[i]>0){

# calculate mean of all orders per comparison!
sumStats <- NULL

for (m in 1:length(order_names)){
path_fw <- paste("Primer_tables_v10/", data$strand[i], "_#_", order_names[m], "_##_", data$Primer.name[i], ".csv", sep="")
path_rw <- paste("Primer_tables_v10/", data$strand[k], "_#_", order_names[m], "_##_", data$Primer.name[k], ".csv", sep="")
sumStats <- rbind(combine_2_primers(path_fw, path_rw, threshold=160), sumStats)
}

sumStats <- sumStats/ rowSums(sumStats)
meep <- colMeans(sumStats[which(order_stats$number_of_reads_fasta>=100),])

pie(meep, col=c("Green", "Red", "Gray"), labels=NA, radius=1, clockwise=T, border=0)
text(0,0, round(meep[1]/sum(meep[-3])*100))
} else {
plot(0, type="n", axes=F, xlab="", ylab="", xlim=c(0,2)) # empty plot
}

}

}

dev.off()



